/* ****************************************************** */
/*    Wilson fermion solver                               */
/*                                                        */
/*    This program is written in C-like manner, but       */
/*   using C++ functions.  Please compile by g++, or      */
/*   other C++ compiler.  [18 Apr 2009 HM]                */
/*                                                        */
/*                     Copyright(c) Hideo Matsufuru 2009  */
/* ****************************************************** */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "lattsize.h"

#include "io_conf.h"

/* ****************************************************** */
void uinit(int istart, double *u){


 if(istart > 2){  // read from file

  FILE *fp;
  fp = fopen("conf_08080816.txt","r");

  //    for(int i=0; i < Ndf*Nst*4; i++){
  //    fscanf(fp, "%lf",&u[i]);
  //    }

  for(int ist=0; ist < Nst; ist++){
   for(int idir=0; idir < 4; idir++){
    for(int idf=0; idf < Ndf; idf++){
      int i = idf + ist*Ndf + idir*Ndf*Nst;
      fscanf(fp, "%lf",&u[i]);
    }
   }
  }

  fclose(fp);

 }else{  // free field

   setunit(Nst*4,u);

 }

}
/* ****************************************************** */
void setunit(int nv, double *u){

  int is;

  for(int i=0; i < nv; i++){

    is = Ndf*i;

    u[   is] = 1.0;   u[ 1+is] = 0.0;
    u[ 2+is] = 0.0;   u[ 3+is] = 0.0;
    u[ 4+is] = 0.0;   u[ 5+is] = 0.0;

    u[ 6+is] = 0.0;   u[ 7+is] = 0.0;
    u[ 8+is] = 1.0;   u[ 9+is] = 0.0;
    u[10+is] = 0.0;   u[11+is] = 0.0;

    u[12+is] = 0.0;   u[13+is] = 0.0;
    u[14+is] = 0.0;   u[15+is] = 0.0;
    u[16+is] = 1.0;   u[17+is] = 0.0;

  }

}
/* ****************************************************** */
