/* ****************************************************** */
/*    Wilson fermion solver                               */
/*                                                        */
/*    This program is written in C-like manner, but       */
/*   using C++ functions.  Please compile by g++, or      */
/*   other C++ compiler.  [18 Apr 2009 HM]                */
/*                                                        */
/*                     Copyright(c) Hideo Matsufuru 2009  */
/* ****************************************************** */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "lattsize.h"

#include "io_conf.h"
#include "cg_wilson.h"

// for CUDA implementation
#include "lib_cuda.h"
#include "cg_wilson_single.h"


/* ****************************************************** */
main(){

  printf("Simple Wilson solver\n\n");

  printf("Nx = %3d, Nx = %3d, Nx = %3d, Nx = %3d\n",
                                       Nx, Ny, Nz, Nt);
  printf("CKs = %10.6f\n", CKs);

  double enorm = 1.E-16;
  printf("enorm = %12.4e\n", enorm);
  double diff;
  int nconv;

  double corr[Nt];
  for(int it=0; it<Nt; it++){
    corr[it] = 0.0;
  }

  double xq[Nvst];
  double bq[Nvst];
  // spinor field

  double u[Ndf*Nst*4];
  // link variable

  int istart = 3;
  uinit(istart, u);

  // CUDA information and saetting
  cuda_init();

  test_WilsonD_gpu(u);


  int Nvt = Nvc*ND*Nx*Ny*Nz;

  printf("  ic  id   nconv      diff\n");

/*
  for(int ic=0; ic<Ncol; ic++){
   for(int id=0; id<ND; id++){
*/

  for(int ic=2; ic<Ncol; ic++){
   for(int id=0; id<ND; id++){

    set_src(ic,id,0,0,0,0,bq);
//    solve_CG(enorm,nconv,diff,xq,u,bq);
    solve_CG_gpu(enorm,nconv,diff,xq,u,bq);
    printf(" %3d %3d  %6d %12.4e\n", ic, id, nconv, diff);

    for(int it=0; it<Nt; it++){
      double corrF;
      normv(Nvt,corrF,&xq[Nvt*it]);
      corr[it] += corrF;
    }

   }
  }

  printf("Ps meson correlator:\n");
  for(int it=0; it<Nt; it++){
    printf(" %6d   %16.8e\n", it, corr[it]);
  }

}
/* ****************************************************** */
